:- use_module(library(plunit)).


:- begin_tests(search, [condition(flag(slow_test, true, true))]).

test('search_parameters') :-
  clear_model,
  command('k for a => b. present(a).'),
  with_output_to(
    atom(Result),
    command('search_parameters(G(Time * 10 < X => a > b), [0 <= k <= 1], [X -> 20], cmaes_init_center: yes).')
  ),
  once(sub_atom(Result, _, _, _, '[0] parameter(k=')).

test('last_period') :-
  clear_model,
  command('present(A). present(B).'),
  command('k1*A*B for A+B => 2*B.'),
  command('k2*A for A => 2*A.'),
  command('k3*B for B => _.'),
  command('parameter(k1=2, k2=2, k3=1).'),
  command('numerical_simulation.'),
  with_output_to(
    atom(_Result),
    command('search_parameters(last_period(A,p),
    [0<=k1<=2, 0<=k2<=2, 0<=k3<=2], [p -> 2]).')
  ).


:- end_tests(search).
